#!/usr/bin/python

import re, sys

xmltv_file_name = sys.argv[1]

print xmltv_file_name

input = open( xmltv_file_name )
input_lines = input.readlines()
input.close()

output = open( xmltv_file_name, "w" )

valid_escape_sequences = {'amp': 1, 'lt': 1, 'gt': 1, 'quot':1, 'apos':1 }

def numeric_escape( string_ ):
    if( string_[0] == '#' ):
        if( re.search( '^#x[0-9a-f]+$', string_, re.IGNORECASE ) ):
            return True
        if( re.search( '^#\d+$', string_ ) ):
            return True


for line in input_lines:
    done = False
    
    while( done == False ):
        # search for invalid escape sequences and delete.
        escape_search = re.search( '&(\S+?);', line )
        if( escape_search ):
            if( escape_search.group(1) not in valid_escape_sequences
                and not numeric_escape( escape_search.group(1) )
              ):
                print line,
                print escape_search.group(1) + "\n"
                line = re.sub( '&' + escape_search.group(1) + ';', '&amp;'+ escape_search.group(1) + ';', line )
                print line
            else:
                done = True
        else:
            done = True
    print >> output, line,